Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/edit/edit.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -2203,393 +1719,13 @@
 static void status_display(char const *str)
 {
-	(void) ui_label_set_text(edit.status, str);
-	(void) ui_label_paint(edit.status);
-}
-
-/** Window close request
- *
- * @param window Window
- * @param arg Argument (edit_t *)
- */
-static void edit_wnd_close(ui_window_t *window, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-
-	ui_quit(edit->ui);
-}
-
-/** Window keyboard event
- *
- * @param window Window
- * @param arg Argument (edit_t *)
- * @param event Keyboard event
- */
-static void edit_wnd_kbd_event(ui_window_t *window, void *arg,
-    kbd_event_t *event)
-{
-	pane.keymod = event->mods;
-
-	if (event->type == KEY_PRESS) {
-		key_handle_press(event);
-		(void) pane_update(&pane);
-		(void) gfx_update(ui_window_get_gc(window));
-	}
-}
-
-/** File / Save menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_file_save(ui_menu_entry_t *mentry, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-
-	(void)edit;
-
-	if (doc.file_name != NULL)
-		file_save(doc.file_name);
-	else
-		file_save_as();
-}
-
-/** File / Save As menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_file_save_as(ui_menu_entry_t *mentry, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-
-	(void)edit;
-	file_save_as();
-}
-
-/** File / Exit menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_file_exit(ui_menu_entry_t *mentry, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-
-	ui_quit(edit->ui);
-}
-
-/** Edit / Cut menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_edit_cut(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	edit_cut();
-	(void) gfx_update(ui_window_get_gc(edit.window));
-}
-
-/** Edit / Copy menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_edit_copy(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	selection_copy();
-}
-
-/** Edit / Paste menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_edit_paste(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	edit_paste();
-	(void) gfx_update(ui_window_get_gc(edit.window));
-}
-
-/** Edit / Delete menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_edit_delete(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-
-	if (selection_active())
-		selection_delete();
+	console_set_pos(con, 0, scr_rows - 1);
+	console_set_style(con, STYLE_INVERTED);
+
+	int pos = -(scr_columns - 3);
+	printf(" %*s ", pos, str);
+	console_flush(con);
+	console_set_style(con, STYLE_NORMAL);
 
 	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	(void) gfx_update(ui_window_get_gc(edit.window));
-}
-
-/** Edit / Select All menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_edit_select_all(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-
-	selection_sel_all();
-	pane.rflags |= (REDRAW_CARET | REDRAW_TEXT | REDRAW_STATUS);
-	pane_update(&pane);
-	(void) gfx_update(ui_window_get_gc(edit.window));
-}
-
-/** Search / Find menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_search_find(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	search_prompt(false);
-}
-
-/** Search / Reverse Find menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_search_reverse_find(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	search_prompt(true);
-}
-
-/** Search / Find Next menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_search_find_next(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	search_repeat();
-	(void) pane_update(&pane);
-	(void) gfx_update(ui_window_get_gc(edit.window));
-}
-
-/** Search / Go To Line menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (edit_t *)
- */
-static void edit_search_go_to_line(ui_menu_entry_t *mentry, void *arg)
-{
-	(void) arg;
-	caret_go_to_line_ask();
-}
-
-/** Save As dialog OK button press.
- *
- * @param dialog Save As dialog
- * @param arg Argument (ui_demo_t *)
- * @param fname File name
- */
-static void save_as_dialog_bok(ui_file_dialog_t *dialog, void *arg,
-    const char *fname)
-{
-	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-	char *cname;
-	errno_t rc;
-
-	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-
-	cname = str_dup(fname);
-	if (cname == NULL) {
-		printf("Out of memory.\n");
-		return;
-	}
-
-	rc = file_save(fname);
-	if (rc != EOK)
-		return;
-
-	if (doc.file_name != NULL)
-		free(doc.file_name);
-	doc.file_name = cname;
-
-}
-
-/** Save As dialog cancel button press.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void save_as_dialog_bcancel(ui_file_dialog_t *dialog, void *arg)
-{
-	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
-	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-}
-
-/** Save As dialog close request.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void save_as_dialog_close(ui_file_dialog_t *dialog, void *arg)
-{
-	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
-	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-}
-
-/** Go To Line dialog OK button press.
- *
- * @param dialog Go To Line dialog
- * @param arg Argument (ui_demo_t *)
- * @param text Submitted text
- */
-static void go_to_line_dialog_bok(ui_prompt_dialog_t *dialog, void *arg,
-    const char *text)
-{
-	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-	char *endptr;
-	int line;
-
-	ui_prompt_dialog_destroy(dialog);
-	line = strtol(text, &endptr, 10);
-	if (*endptr != '\0') {
-		status_display("Invalid number entered.");
-		return;
-	}
-
-	caret_move_absolute(line, pane.ideal_column, dir_before, false);
-	// TODO Smarter cursor management
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-	(void) gfx_update(gc);
-}
-
-/** Go To Line dialog cancel button press.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void go_to_line_dialog_bcancel(ui_prompt_dialog_t *dialog, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
-	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-}
-
-/** Go To Line dialog close request.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void go_to_line_dialog_close(ui_prompt_dialog_t *dialog, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
-	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-}
-
-/** Search dialog OK button press.
- *
- * @param dialog Search dialog
- * @param arg Argument (ui_demo_t *)
- * @param text Submitted text
- */
-static void search_dialog_bok(ui_prompt_dialog_t *dialog, void *arg,
-    const char *text)
-{
-	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-	char *pattern;
-	bool reverse;
-
-	ui_prompt_dialog_destroy(dialog);
-
-	/* Abort if search phrase is empty */
-	if (text[0] == '\0')
-		return;
-
-	pattern = str_dup(text);
-	reverse = pane.search_reverse;
-
-	if (pane.previous_search)
-		free(pane.previous_search);
-	pane.previous_search = pattern;
-	pane.previous_search_reverse = reverse;
-
-	search(pattern, reverse);
-
-	// TODO Smarter cursor management
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-	(void) gfx_update(gc);
-}
-
-/** Search dialog cancel button press.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void search_dialog_bcancel(ui_prompt_dialog_t *dialog, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
-	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-}
-
-/** Search dialog close request.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void search_dialog_close(ui_prompt_dialog_t *dialog, void *arg)
-{
-	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
-	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
Index: uspace/app/edit/meson.build
===================================================================
--- uspace/app/edit/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/edit/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2005 Martin Decky
 # Copyright (c) 2007 Jakub Jermar
@@ -29,5 +28,4 @@
 #
 
-deps = [ 'ui' ]
 src = files(
 	'edit.c',
Index: uspace/app/gfxdemo/gfxdemo.c
===================================================================
--- uspace/app/gfxdemo/gfxdemo.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/gfxdemo/gfxdemo.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -73,16 +73,4 @@
 static gfx_coord_t vpad;
 
-/** Determine if we are running in text mode.
- *
- * @param w Screen width
- * @param h Screen height
- * @return @c true iff we are running in text mode
- */
-static bool demo_is_text(gfx_coord_t w, gfx_coord_t h)
-{
-	// XXX Need a proper way to determine text mode
-	return w <= 80;
-}
-
 /** Clear screen.
  *
@@ -227,13 +215,7 @@
 
 	if (font != NULL) {
-		if (demo_is_text(w, h)) {
-			rc = gfx_color_new_ega(0x1e, &color);
-			if (rc != EOK)
-				goto error;
-		} else {
-			rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
-			if (rc != EOK)
-				goto error;
-		}
+		rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
+		if (rc != EOK)
+			goto error;
 
 		gfx_text_fmt_init(&fmt);
@@ -678,13 +660,7 @@
 	gfx_color_delete(color);
 
-	if (demo_is_text(w, h)) {
-		rc = gfx_color_new_ega(0x1f, &color);
-		if (rc != EOK)
-			goto error;
-	} else {
-		rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
-		if (rc != EOK)
-			goto error;
-	}
+	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
+	if (rc != EOK)
+		goto error;
 
 	gfx_text_fmt_init(&fmt);
@@ -706,5 +682,5 @@
 		goto error;
 
-	pos.x = rect.p1.x;
+	pos.x = rect.p1.x - 1;
 	pos.y = rect.p0.y;
 	fmt.halign = gfx_halign_right;
@@ -729,5 +705,5 @@
 		goto error;
 
-	pos.x = rect.p1.x;
+	pos.x = rect.p1.x - 1;
 	pos.y = (rect.p0.y + rect.p1.y - 1) / 2;
 	fmt.halign = gfx_halign_right;
@@ -746,5 +722,5 @@
 
 	pos.x = (rect.p0.x + rect.p1.x - 1) / 2;
-	pos.y = rect.p1.y;
+	pos.y = rect.p1.y - 1;
 	fmt.halign = gfx_halign_center;
 	rc = gfx_puttext(font, &pos, &fmt, "Bottom center");
@@ -752,6 +728,6 @@
 		goto error;
 
-	pos.x = rect.p1.x;
-	pos.y = rect.p1.y;
+	pos.x = rect.p1.x - 1;
+	pos.y = rect.p1.y - 1;
 	fmt.halign = gfx_halign_right;
 	rc = gfx_puttext(font, &pos, &fmt, "Bottom right");
@@ -764,14 +740,8 @@
 
 	for (i = 0; i < 8; i++) {
-		if (demo_is_text(w, h)) {
-			rc = gfx_color_new_ega(i != 0 ? i : 0x10, &color);
-			if (rc != EOK)
-				goto error;
-		} else {
-			rc = gfx_color_new_rgb_i16((i & 4) ? 0xffff : 0,
-			    (i & 2) ? 0xffff : 0, (i & 1) ? 0xffff : 0, &color);
-			if (rc != EOK)
-				goto error;
-		}
+		rc = gfx_color_new_rgb_i16((i & 4) ? 0xffff : 0,
+		    (i & 2) ? 0xffff : 0, (i & 1) ? 0xffff : 0, &color);
+		if (rc != EOK)
+			goto error;
 
 		fmt.color = color;
Index: uspace/app/hello/hello.c
===================================================================
--- uspace/app/hello/hello.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/hello/hello.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -80,15 +80,8 @@
 	ui_wnd_params_init(&params);
 	params.caption = "Hello World";
-	if (ui_is_textmode(ui)) {
-		params.rect.p0.x = 0;
-		params.rect.p0.y = 0;
-		params.rect.p1.x = 24;
-		params.rect.p1.y = 5;
-	} else {
-		params.rect.p0.x = 0;
-		params.rect.p0.y = 0;
-		params.rect.p1.x = 200;
-		params.rect.p1.y = 60;
-	}
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p1.x = 200;
+	params.rect.p1.y = 60;
 
 	memset((void *) &hello, 0, sizeof(hello));
@@ -118,8 +111,10 @@
 	}
 
-	ui_window_get_app_rect(window, &rect);
+	rect.p0.x = 10;
+	rect.p0.y = 35;
+	rect.p1.x = 190;
+	rect.p1.y = 50;
 	ui_label_set_rect(hello.label, &rect);
 	ui_label_set_halign(hello.label, gfx_halign_center);
-	ui_label_set_valign(hello.label, gfx_valign_center);
 
 	rc = ui_fixed_add(hello.fixed, ui_label_ctl(hello.label));
Index: uspace/app/inet/inet.c
===================================================================
--- uspace/app/inet/inet.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/inet/inet.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,5 +37,4 @@
 #include <errno.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <inet/inetcfg.h>
 #include <io/table.h>
@@ -341,5 +340,4 @@
 	inet_link_info_t linfo;
 	table_t *table = NULL;
-	eth_addr_str_t saddr;
 
 	size_t count;
@@ -370,7 +368,10 @@
 		}
 
-		eth_addr_format(&linfo.mac_addr, &saddr);
-		table_printf(table, "%s\t %s\t %zu\n", saddr.str, linfo.name,
-		    linfo.def_mtu);
+		table_printf(table, "%02x:%02x:%02x:%02x:%02x:%02x\t"
+		    "%s\t" "%zu\n",
+		    linfo.mac_addr[0], linfo.mac_addr[1],
+		    linfo.mac_addr[2], linfo.mac_addr[3],
+		    linfo.mac_addr[4], linfo.mac_addr[5],
+		    linfo.name, linfo.def_mtu);
 
 		free(linfo.name);
Index: uspace/app/tester/meson.build
===================================================================
--- uspace/app/tester/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2005 Martin Decky
 # Copyright (c) 2007 Jakub Jermar
@@ -29,5 +28,5 @@
 #
 
-deps = [ 'block', 'codepage', 'drv', 'math' ]
+deps = [ 'block', 'drv', 'math' ]
 src = files(
 	'tester.c',
Index: uspace/app/tester/print/print4.c
===================================================================
--- uspace/app/tester/print/print4.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/print/print4.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2009 Martin Decky
  * All rights reserved.
@@ -28,5 +27,4 @@
  */
 
-#include <codepage/cp437.h>
 #include <stdio.h>
 #include <stddef.h>
@@ -53,22 +51,12 @@
 	}
 
-	/*
-	 * Print entire code page 437 (in Unicode)
-	 *
-	 * The purpose of this test is to verify that the EGA display
-	 * driver can correctly map every code page 437 character back
-	 * from Unicode and display it.
-	 *
-	 * With a Unicode-capable display this will just give you a bit
-	 * of nostalgia.
-	 */
-	TPRINTF("\nCode page 437 characters (converted to Unicode):\n");
+	TPRINTF("\nExtended ASCII characters (128 - 255) using printf(\"%%lc\"):\n");
 
-	for (group = 0; group < 8; group++) {
+	for (group = 4; group < 8; group++) {
 		TPRINTF("%#x: ", group << 5);
 
 		uint8_t index;
 		for (index = 0; index < 32; index++)
-			TPRINTF("%lc", cp437_decode((group << 5) + index));
+			TPRINTF("%lc", (wint_t) ((group << 5) + index));
 
 		TPRINTF("\n");
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tetris/screen.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -72,6 +72,5 @@
 static int isset;               /* true => terminal is in game mode */
 
-static bool use_rgb;          /* true => use RGB colors */
-static bool use_color;          /* true => use indexed colors */
+static bool use_color;          /* true => use colors */
 
 static const struct shape *lastshape;
@@ -93,21 +92,7 @@
 static void start_standout(uint32_t color)
 {
-	uint8_t bg;
-	uint8_t attr;
-
 	console_flush(console);
-	if (use_rgb) {
-		console_set_rgb_color(console, color, 0xffffff);
-	} else if (use_color) {
-		bg = 0x00;
-		attr = 0;
-		if ((color & 0xff0000) != 0)
-			bg |= 0x4;
-		if ((color & 0x00ff00) != 0)
-			bg |= 0x2;
-		if ((color & 0x0000ff) != 0)
-			bg |= 0x1;
-		console_set_color(console, bg, 0x00, attr);
-	}
+	console_set_rgb_color(console, use_color ? color : 0x000000,
+	    0xffffff);
 }
 
@@ -158,17 +143,13 @@
 }
 
-static void get_display_color_sup(bool *rgb, bool *color)
+static bool get_display_color_sup(void)
 {
 	sysarg_t ccap;
 	errno_t rc = console_get_color_cap(console, &ccap);
 
-	if (rc != EOK) {
-		*rgb = false;
-		*color = false;
-		return;
-	}
-
-	*rgb = ((ccap & CONSOLE_CAP_RGB) == CONSOLE_CAP_RGB);
-	*color = ((ccap & CONSOLE_CAP_INDEXED) == CONSOLE_CAP_INDEXED);
+	if (rc != EOK)
+		return false;
+
+	return ((ccap & CONSOLE_CAP_RGB) == CONSOLE_CAP_RGB);
 }
 
@@ -188,5 +169,5 @@
 	}
 
-	get_display_color_sup(&use_rgb, &use_color);
+	use_color = get_display_color_sup();
 
 	if ((Rows < MINROWS) || (Cols < MINCOLS)) {
